//No Damage RJ - for v2.5.1
//   by Cerapter

//Check for version
if VERSION != 25100
{
	show_message("Warning!##This plugin (No Damage RJ) can only be used in Gang Garrison's #> 2.5.1 <#version.##Check out the plugin's thread on the Gang Garrison Forums for a newer version.##The game will end now.")
	game_end();
}

//Is it a rocketjumping map? (Does its name start with "rj"?)
if object_index == Client {checkMap = string_copy(string(downloadMapName),0,2)};
if object_index == GameServer {checkMap = string_copy(string(global.currentMap),0,2)};

if checkMap == "rj" or checkMap == "sj"
{

//We do not want the characters to be able to hit eachother with rockets
object_event_clear(Rocket,ev_collision,Character)
object_event_add(Rocket,ev_collision,Character,"
if (!fade)
{
        alarm[0] = 31 - travelDistance;
}
")

//Ignore everybody but the owner when dealing pushback and damage is needed
object_event_clear(Rocket,ev_other,ev_user5)
object_event_add(Rocket,ev_other,ev_user5,"
{  
    if(characterHit.id != ownerPlayer.object)
    {
        if(exploded)
            exit;
        else
            exploded = true;
        if(characterHit != -1) {
            if(characterHit.team != team || characterHit.id == ownerPlayer.object  && characterHit.ubered == 0 ) {
                characterHit.hp -= hitDamage;
                characterHit.timeUnscathed = 0;
                if object_is_ancestor(characterHit.object_index, Character) {
                    if (characterHit.lastDamageDealer != ownerPlayer && characterHit.lastDamageDealer != characterHit.player){
                        characterHit.secondToLastDamageDealer = characterHit.lastDamageDealer;
                        characterHit.alarm[4] = characterHit.alarm[3]
                    }
                    characterHit.alarm[3] = ASSIST_TIME;
                }
                characterHit.lastDamageDealer = ownerPlayer;
                characterHit.lastDamageSource = weapon;
            }
        }
        instance_create(x,y,Explosion);
        playsound(x,y,ExplosionSnd);
        
        with (Character) {
            if (distance_to_object(other) < other.blastRadius and id == other.ownerPlayer.object){
				//I'm honestly not sure what to do with the 
				//and !place_meeting(x, y+1, Obstacle)
				//part
				
                var rdir, vectorfactor;
                rdir = point_direction(other.x,other.y,x,y);
                vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
                    continue;
                motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
                if(!ubered and hp > 0)
                {
                    if (other.team != team) or (id==other.ownerPlayer.object)
                    {
                        hp -= other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                        timeUnscathed = 0;
                        if(id == other.ownerPlayer.object and lastDamageDealer != -1 and lastDamageDealer != other.ownerPlayer)
                        {
                            lastDamageSource = FINISHED_OFF_GIB;
                        }
                        else 
                        {
                            if (lastDamageDealer != other.ownerPlayer && lastDamageDealer != player){
                                secondToLastDamageDealer = lastDamageDealer;
                                alarm[4] = alarm[3]
                            }
                            if (other.ownerPlayer != id)
                                alarm[3] = ASSIST_TIME;
                            lastDamageDealer = other.ownerPlayer;
                            lastDamageSource = other.weapon;
                        }
                        cloakAlpha = max(cloakAlpha, 0.3);
                        cloakFlicker = true;
                        alarm[7] = 3;
                    }
                    if id==other.ownerPlayer.object and other.team == team {
                        moveStatus = 1;
                        speed*=1.06;
                    }else if other.team == team and (id!=other.ownerPlayer.object){
                        moveStatus = 4;
                            if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(distance_to_object(other)/other.blastRadius));
                            speed*=1.3;
                        }
                    } else {
                        moveStatus = 2;
                        if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(distance_to_object(other)/other.blastRadius));
                            speed*=1.3;
                        }
                    }
                    if(global.gibLevel > 0) {
                        if (id==other.ownerPlayer.object) or (other.team!=team) {
                            repeat(3) {
                                var blood;
                                blood = instance_create(x,y,Blood);
                                blood.direction = point_direction(other.x,other.y,x,y)-180;
                            }
                        }
                    }
                }
            }
        }

        with (Sentry) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team) {
                    hp -= other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }        
        
        with (Generator) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team) {
                    alarm[0] = regenerationBuffer;
                    isShieldRegenerating = false;
                    //allow overkill to be applied directly to the target
                    var hitDamage;
                    hitDamage = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                    if (hitDamage > shieldHp) {
                        hp -= hitDamage - shieldHp;
                        hp -= shieldHp * shieldResistance;
                        shieldHp = 0;
                    } else {
                        hp -= hitDamage * shieldResistance;
                        shieldHp -= hitDamage;
                    }
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }
        
        with (DeadGuy) {
          if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
          }
        }
        
        with (Gib) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
                rotspeed=random(151)-75;
            }
        }
    
        //Mines are ignored
        
        with(LooseSheet) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
            }
        }
        
        with(Bubble) {
            if (distance_to_object(other) < other.blastRadius*0.66){
                alarm[0]-=200;
            }    
        }

        instance_destroy();
    }
}
")

//Mines ignore other mines and players
object_event_clear(Mine,ev_other,ev_user2)
object_event_add(Mine,ev_other,ev_user2,"
{
    if(exploded == true) {
        exit;
    } else {
        exploded = true;
    }
    instance_create(x,y,Explosion);
    playsound(x,y,ExplosionSnd);
    
    with (Character) {
        if (distance_to_object(other) < other.blastRadius and id == other.ownerPlayer.object)
        {
		//I'm honestly not sure what to do with the 
		//and !place_meeting(x, y+1, Obstacle)
		//part
            var rdir, vectorfactor;
            rdir = point_direction(other.x,other.y,x,y);
            vectorfactor = point_distance(0, 0, sin(degtorad(rdir)), cos(degtorad(rdir)));
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
                continue;
            motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
            if((other.team != team or id==other.ownerPlayer.object) and !ubered and hp > 0)
            {
                var dmg;
                dmg = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                if id == other.ownerPlayer.object// self damage resistance
                    dmg *= 5/9;
                hp -= dmg;
                timeUnscathed = 0;
                if (id == other.ownerPlayer.object and lastDamageDealer != -1 and lastDamageDealer != other.ownerPlayer and other.reflector == noone)
                    lastDamageSource = FINISHED_OFF_GIB;
                else 
                {
                    if (lastDamageDealer != other.ownerPlayer and lastDamageDealer != player and other.reflector != lastDamageDealer)
                    {
                        secondToLastDamageDealer = lastDamageDealer;
                        alarm[4] = alarm[3]
                    }
                    if (other.ownerPlayer != id or (other.reflector != noone and other.ownerPlayer == id))
                        alarm[3] = ASSIST_TIME;
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                    if (id==other.ownerPlayer.object and other.reflector != noone)
                    {
                        lastDamageDealer = other.reflector;
                        lastDamageSource = WEAPON_REFLECTED_STICKY;
                    }
                }
                if(global.gibLevel > 0)
                {
                    repeat(3)
                    {
                        var blood;
                        blood = instance_create(x,y,Blood);
                        blood.direction = point_direction(other.x,other.y,x,y)-180;
                    }
                }
                if (id==other.ownerPlayer.object)
                {
                    moveStatus = 1;
                    vspeed*=0.8;
                }
                else if (other.team == team)
                {
                    moveStatus = 2;
                    vspeed*=0.8;
                }
                else
                {
                    moveStatus = 4;
                    vspeed*=0.8
                }
            }
            cloakAlpha = max(cloakAlpha, 0.3);
            cloakFlicker = true;
            alarm[7] = 3;
        }
    }

    
    with (Sentry){
        if (distance_to_object(other) < other.blastRadius) && (team != other.team) { 
        hp -= other.explosionDamage*10/9*(1-(distance_to_object(other)/other.blastRadius)); // we want sentries to take ~11% extra damage so that two stickies will do 100 instead of 90 dmg. we don't change the base damage so scouts can't be 2-hitted.
        lastDamageDealer = other.ownerPlayer;
        lastDamageSource = WEAPON_MINEGUN;
        }   
    }    
     
     with (Generator){
        if (distance_to_object(other) < other.blastRadius) && (team != other.team) { 
            alarm[0] = regenerationBuffer;
            isShieldRegenerating = false;
            //allow overkill to be applied directly to the target
            var hitDamage;
            hitDamage = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
            if (hitDamage > shieldHp) {
                hp -= hitDamage - shieldHp;
                hp -= shieldHp * shieldResistance;
                shieldHp = 0;
            } else {
                hp -= hitDamage * shieldResistance;
                shieldHp -= hitDamage;
            }
        }   
    }
       
    //Rockets are ignored
    
    with (DeadGuy) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        }
    }
    
	//Enemy mines are ignored
    with(Mine) {
        if (distance_to_object(other) < other.blastRadius*0.66 and other.ownerPlayer == ownerPlayer){
            event_user(2);
        }
    }
    with (Gib) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
            rotspeed=random(151)-75;
        }
    }
    
    with(LooseSheet) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        }
    }
    with(Bubble) {
        if (distance_to_object(other) < other.blastRadius*0.66){
        alarm[0]-=200;
        }    
    }

    instance_destroy();
}
")

//END OF CODE
}